/*
* /giis/file.c This file contains procedures to read data block and displays conents
* of giis_files.
*
* Copyright (C) 2005 G.Lakshmipathi.<lakshmipathi_g@rediffmail.com>
*
* This file may be redistributed under the terms of the GNU Public License.
*
* Keep Spirit of Open Source alive.forever.
*/

#include "giis.h"

/*
* read_show_file() -  Reads data from given block and stores into a files.
* size is global variable used to specify the remaining file size after every read.
*/

int read_show_file(int fd,int fp){
int i,count=0;	
char buffer[4096],a;  /* buffer_size=fs.block_size */
while((count<fs.block_size)&&(size>0)){

			/*Reading char by char */
			
	if(size<sizeof(buffer) && size>0){
		i=read(fd,&a,1); 
		while(size && count<fs.block_size){ 
			
			i=write(fp,&a,1);
			if(i!=1)
			ERROR
			size--;
			err_size++;
			count++;
			i=read(fd,&a,1);
		}
	}
	
			/*Read block by block */
	
	if(size>=sizeof(buffer)&&(count==0)){
		i=read(fd,buffer,sizeof(buffer));
		if(i!=sizeof(buffer))
				ERROR
		i=write(fp,buffer,sizeof(buffer));
		if(i!=sizeof(buffer))
				ERROR
		size-=sizeof(buffer);
		err_size+=sizeof(buffer);
		count=fs.block_size;
			
	}
}
return(size);
}

/*
* read_dir_info_file() read data from dir_info_file and displays. 
*/

int read_dir_info_file(){
int i,count=0;
char dname[50];


	fd=open(DIR_INFO_FILE,0);
		if(fd==-1){
			perror("open");
			return -1;
		}
	printf("Enter dir:");
	scanf("%s",dname);
	printf("\n\tName\tinode\tParent-inode\tSearchFlag\n"); 
       	i=read(fd,giis_d.buffer,GIIS_DSIZE);
       	
	while(i>0){
	if(giis_d.info.search_flag==1){
		printf("\n%s\t%u\t",giis_d.info.name,giis_d.info.inode_number);
	printf("%u\t%d",giis_d.info.parent_inode_number,giis_d.info.search_flag);	

	count++;
	}
	if(strcmp(dname,giis_d.info.name)==0)
	return 1;
	

	
		i=read(fd,giis_d.buffer,GIIS_DSIZE);
		CHECK
	}
	
printf("\n Total No.of Dir : %d",count);
close(fd);
return 1;
}
	
/*
* read_file_info_file() read data from file_info_file and displays. 
* Modification for giis2:
* New members like id_offset and is_offset used to keep trace of no.of blocks entry of
* particular files in sind and dind files.
* Where as s_offy and d_offy used for set offset in sind and dind files.
*/

int read_file_info_file(){
int i,fd,count=0,choice;
int index,hole,num;
unsigned long indirect_block;
char fname[50];
	fd=open(FILE_INFO_FILE,0);
	if(fd==-1){
		perror("open");
		return -1;
	}
	printf("\n\t\tPress 1: All files");
	printf("\n\t\tPress 2: Specific file");
	printf("\n\t\tType in:");
	scanf("%d",&choice);
	if(choice==2){
	printf("\n\t\t Enter filename :");
	scanf("%s",fname);
	}
	else
	choice=1;
	
	
       	i=read(fd,giis_f.buffer,GIIS_FSIZE);
	while(i>0){
		count++;

		printf("\nFile name   :%s",giis_f.info.name);
		printf("\tInode :%u",giis_f.info.inode_number);		  
		printf("  sfragment_flags:%d ",giis_f.info.sfragment_flag);	
		printf("  dfragment_flags:%d ",giis_f.info.dfragment_flag);	
		printf("  is_offset %u ",giis_f.info.is_offset);
		printf("  id_offset %u ",giis_f.info.id_offset);
		
		printf("\nRecorded on :%s",giis_f.info.date_time);
		printf("\t\tFile name   :%s",giis_f.info.name);
		printf("\nInode :%u",giis_f.info.inode_number);		  
		printf("\tParent :%u",giis_f.info.parent_inode_number);	  
		printf("\tSearch Flag: %d",giis_f.info.search_flag);
		printf("\tMode:%d",giis_f.info.mode);				  
		printf("\nOwner: %d",giis_f.info.owner);		  		  
		printf("\tBlocks count:%u",giis_f.info.file_blocks_count);	  
		printf("\tSize: %u",giis_f.info.file_size);		
		
		printf("\nData blocks :");
		for(i=0;i<EXT3_N_BLOCKS;i++)
		printf("\n[%d]=%u",i,giis_f.info.data_block[i]);
		printf("\nsingles");
		printf("\nis_offset=%u\n id=%u",giis_f.info.is_offset,giis_f.info.id_offset);
		printf("\ns_offy=%u \t d_offy=%u",s_offy,d_offy);

	
		if(giis_f.info.is_offset){
		read_sind_info_file();		
		s_offy+=giis_f.info.is_offset;
		}

		if(giis_f.info.id_offset){
		read_dind_info_file();
		d_offy+=giis_f.info.id_offset;
		}
		printf("\nis_offset=%u\n id=%u",giis_f.info.is_offset,giis_f.info.id_offset);
		printf("\ns_offy=%u \t d_offy=%u",s_offy,d_offy);
		printf("\nLast :%u",giis_f.info.last_data_block);		  

	
	
	if(strcmp(fname,giis_f.info.name)==0 && choice==2){
	printf("\n\t\tPress 0:Try next file\n\t\tPress 1:Exit \n\t\tType in:");
	scanf("%d",&i);
	if(i!=0)
	return 1;

	}
	if(choice==1){	
		printf("\n\t\tPress 0:Continue\n\t\tPress 1 : Stop");
		printf("\n\t\tEnter your choice:");
		scanf("%d",&i);
		if(i==1)
		return 1;
		}
		

		i=read(fd,giis_f.buffer,GIIS_FSIZE);
		CHECK
	}
printf("\n Total No.of Files : %d",count);
close(fd);					
return 1;
}


/*
* read_sind_info_file() read data from sind and displays. 
* introduced for giis2.
* s_offy specifies offset at sind file.
* is_offset gives total no.of entries of this record.
*/

int read_sind_info_file(){
int i,fp;
unsigned long iblock[1024];

	fp=open(SIND_INFO_FILE,0);
		if(fp==-1){
			perror("open");
			return -1;
		}
	lseek(fp,s_offy*sizeof(unsigned long),0);
       	read(fp,iblock,giis_f.info.is_offset*sizeof(unsigned long));
       	CHECK
       	i=0;
   	while(i<giis_f.info.is_offset){

       		printf("\n%d==>%u",i,iblock[i]);
       		i++;

	}
printf("\n SIND No.of records :%d",i);					
close(fp);
return 1;
}
/*
* read_dind_info_file() read data from dind and displays. 
* introduced for giis2.
* d_offy specifies offset at dind file.
* id_offset gives total no.of entries of this record.
*/

int read_dind_info_file(){
int i,fp;
unsigned long iblock[1024];

	fp=open(DIND_INFO_FILE,0);
		if(fp==-1){
			perror("open");
			return -1;
		}
	lseek(fp,d_offy*sizeof(unsigned long),0);
       	read(fp,iblock,giis_f.info.id_offset*sizeof(unsigned long));
       	CHECK
       	i=0;
       	
   	while(i<giis_f.info.id_offset){
       		printf("\n%d==>%u",i,iblock[i]);
       		i++;

	}

printf("\n DIND No.of records :%d",i);					
close(fp);
return 1;
}
